import create from 'dd-store'
import exampleStore from '/stores/exampleStore'
import { addSchedule, getUserScheduleInTime, getHomeUserSchedule } from '../../api/request.js'
create.Page({
  store: exampleStore,
  useAll: true,
  time1: '',
  time2: '',
  data: {
    scheduleItem: '',
    requireUsers: [],
    organizer: '',
    permissions: '',
    requireUsersInfo: []
  },
  onLoad(event) {
    let permissions = getApp().globalData.userid
    let scheduleItem = JSON.parse(event.scheduleItem)
    let organizer = event.organizer
    let requireUsers = JSON.parse(event.requireUsers)
    let requireUsersInfo = JSON.parse(event.requireUsersInfo)
    this.setData({
      requireUsers: requireUsers,
      organizer: organizer,
      scheduleItem: scheduleItem,
      time1: scheduleItem.startTime,
      time2: scheduleItem.endTime,
      permissions: permissions,
      requireUsersInfo: requireUsersInfo
    })
    dd.setNavigationBar({
      title: `参会人(${this.store.data.participatorList.length}人）`
    })
    this.conflict()
  },
  // 保存信息
  saveInfo() {
    dd.navigateBack({
      delta: 1
    })
  },
  // 添加参会人
  addParticipants() {
    const _that = this
    let require = []
    let select = []
    if (!this.data.scheduleItem || this.data.organizer === getApp().globalData.userid) {
      select = this.store.data.participatorUserId
      require = [getApp().globalData.userid]
      select.forEach((item, index) => {
        if (item.userId == getApp().globalData.userid) {
          select.splice(index, 1)
        }
      })
    } else {
      select = [...this.store.data.participatorUserId]
      require = [...this.data.requireUsers]
    }
    select = _that.selectedelRequired(require, select).pickedUsers
    dd.complexChoose({
      title: "选择参会人",            //标题
      multiple: true,            //是否多选
      pickedUsers: select, //已选用户
      requiredUsers: require,            //必选用户（不可取消选中状态）
      responseUserOnly: true,        //返回人，或者返回人和部门
      success: function (res) {
        if (!_that.data.scheduleItem || _that.data.organizer === getApp().globalData.userid) {
          _that.store.data.participatorList = []
          _that.store.data.participatorUserId = []
          _that.store.data.participatorList.push({ userId: getApp().globalData.userid, username: getApp().globalData.name, headUrl: getApp().globalData.avatar })
          _that.store.data.participatorUserId.push(getApp().globalData.userid)
          res.users.forEach((item, index) => {
            _that.store.data.participatorList.push({ userId: item.userId, username: item.name, headUrl: item.avatar })
            _that.store.data.participatorUserId.push(item.userId)
          })
        } else {
          _that.store.data.participatorList = []
          _that.store.data.participatorUserId = []
          _that.data.requireUsersInfo.forEach((item, index) => {
            _that.store.data.participatorList.push({ userId: item.userId, username: item.username, headUrl: item.headUrl })
            _that.store.data.participatorUserId.push(item.userId)
          })
          res.users.forEach((item, index) => {
            _that.store.data.participatorList.push({ userId: item.userId, username: item.name, headUrl: item.avatar })
            _that.store.data.participatorUserId.push(item.userId)
          })
        }
        _that.store.data.participatorList = _that.setArrary(_that.store.data.participatorList)
        _that.store.data.participatorUserId = [...new Set(_that.store.data.participatorUserId)]
        _that.conflict()
        _that.update()
      },
      fail: function (err) {
      }
    })
  },
  // 删除参会人
  delParticipants(event) {
    let userId = event.target.dataset.userId
    this.store.data.participatorList.forEach((item, index) => {
      if (userId === item.userId) {
        this.store.data.participatorList.splice(index, 1)
        this.update()
        return
      }
    })
    this.store.data.participatorUserId.forEach((item, index) => {
      if (userId === item) {
        this.store.data.participatorUserId.splice(index, 1)
        this.update()
        return
      }
    })
    dd.setNavigationBar({
      title: `参会人(${this.store.data.participatorList.length}人）`
    })
    this.conflict()
  },
  // 数组去重
  setArrary(arr, userId) {
    console.log(arr)
    let containt = {}
    for (let x of arr) {
      containt['id' + x.userId] = x
    }
    return Object.values(containt)
  },
  // 会议冲突
  conflict() {
    this.store.data.conflictPeople = []
    let data = {
      startTime: `${this.data.time1}`,
      endTime: `${this.data.time2}`,
      userIds: this.store.data.participatorUserId
    }
    getUserScheduleInTime(data).then(res => {
      for (let value in res.data.data) {
        if (!!this.data.scheduleItem) {
          if (res.data.data[value].length > 1) {
            this.store.data.conflictPeople.push(value)
          }
        } else {
          if (res.data.data[value].length > 0) {
            this.store.data.conflictPeople.push(value)
          }
        }

      }
      this.update()
    })
  },
  // 已选用户去中去掉必选用户
  selectedelRequired(req, pic) {
    for (let i = 0; i < req.length; i++) {
      for (let m = 0; m < pic.length; m++) {
        if (req[i] == pic[m]) {
          pic.splice(m, 1)
          m--;
        }
      }
    }
    return {
      requiredUsers: req,
      pickedUsers: pic
    }
  }
});
