import create from 'dd-store'
import exampleStore from '/stores/exampleStore'
import { queryAvailableMeetingRoomByTime } from './../../api/request'
import { throttle } from './../../utils/utils.js'
create.Page({
  store: exampleStore,
  useAll: true,
  data: {
    place: '',
    availableMeetingRoom: []
  },
  onLoad(e) {
    dd.setNavigationBar({
      title: '会议地点'
    })
    let that = this
    let data = {
      startTime: this.store.data.startTime.replace(/\//g, "-"),
      endTime: this.store.data.endTime.replace(/\//g, "-")
    }
    queryAvailableMeetingRoomByTime(data).then(res => {
      that.setData({
        availableMeetingRoom: res.data.data
      })
    })
  },
  selectPlace(event) {
    this.store.data.locationName = event.target.dataset.locationName
    this.store.data.roomId = ''
    this.update()
    dd.navigateBack({
      delta: 1
    })
  },
  selectMeetingRoom(e) {
    this.store.data.locationName = e.target.dataset.locationName
    this.store.data.roomId = e.target.dataset.locationid
    this.update()
    dd.navigateBack({
      delta: 1
    })
  },
  inputPlace(event) {
    this.setData({
      place: event.detail.value
    })
  },
  toRoomList: throttle(function () {
    dd.navigateTo({ url: `./../meetingRoomList/meetingRoomList` })
  }, 1000)
});
